import { DocsState } from '../docs/reducers';
import { SessionState } from '../sessions/reducers';
import { SharingState } from '../sharing/reducers';
import { HistoryState } from '../history/reducers';
import { Map, Record, OrderedMap } from 'immutable';
import { GeneralState } from '../general/reducers';
import { AppHistory } from '../appHistory/reducers';
export declare function getSelectedWorkspaceId(state: any): any;
export declare function getSelectedWorkspace(state: any): any;
declare const Workspace_base: Record.Factory<{
    docs: Map<string, {}>;
    sessions: SessionState;
    sharing: SharingState;
    history: OrderedMap<{}, {}>;
    general: GeneralState;
    appHistory: AppHistory;
}>;
export declare class Workspace extends Workspace_base {
    docs: DocsState;
    sessions: SessionState;
    sharing: SharingState;
    history: HistoryState;
    general: GeneralState;
    appHistory: AppHistory;
}
export declare const defaultSettings: {
    'general.betaUpdates': boolean;
    'editor.theme': string;
    'editor.reuseHeaders': boolean;
    'request.credentials': string;
    'tracing.hideTracingResponse': boolean;
};
export declare const RootState: Record.Factory<any>;
export declare const rootReducer: (state: (Record<any> & Readonly<any>) | undefined, action: any) => any;
export declare function makeWorkspace(endpoint: any): any;
export default rootReducer;
export declare const getSessionCounts: (arg: any) => any;
export declare const getSettingsString: (state: any) => any;
export declare const getSettings: ((state: any) => any) & {
    resultFunc: (res: any) => any;
    recomputations: () => number;
    resetRecomputations: () => number;
};
export declare const getTheme: ((state: any) => any) & {
    resultFunc: (res: any) => any;
    recomputations: () => number;
    resetRecomputations: () => number;
};
